<template>
    <v-layout justify-center row>
        <v-flex xs12 sm10 md8 lg6 class="elevation-4 pa-3 ma-1 white text-xs-center">
            <h1 class="mt-1 display-1">Kontakt</h1>

            <p class="mt-3">Tel nr: {{this.contactInfo.ContactNumber}}

                <!--round loader-->
                <v-progress-circular
                        v-show="isLoading === true"
                        indeterminate
                        color="primary"
                ></v-progress-circular>

                <!--show edit button to administrator when to button is not clicked and the page is not loading-->
                <v-btn fab small color="primary" v-if="this.user.role === 'admin' && !this.edit.ContactNumber && this.isLoading === false"
                       @click="edit.ContactNumber = !edit.ContactNumber">
                    <i class="material-icons ml2">
                        create
                    </i>
                </v-btn>

                <!--if edit button is clicked-->
                <v-flex v-if="edit.ContactNumber === true">
                    <!--validate and show text field-->
                    <v-text-field
                            v-model="contactInfo.ContactNumber"
                            label="Uus kontaktnumber"
                            type="number"
                            :rules="numberRules"
                    ></v-text-field>

                    <!--show check icon and send data to "change" function-->
                    <v-btn color="primary" small fab>
                        <i class="material-icons"
                           @click="change('ContactNumber', contactInfo.ContactNumber, user.role)">
                            check
                        </i>
                    </v-btn>
                    <!--show clear icon and cancel editing-->
                    <v-btn color="error" fab small @click="edit.ContactNumber = !edit.ContactNumber">
                        <i class="material-icons">
                            clear
                        </i>
                    </v-btn>
                </v-flex>
            </p>

            <p>
                E-mail: {{ this.contactInfo.ContactEmail }}
                <v-progress-circular
                        v-show="isLoading === true"
                        indeterminate
                        color="primary"
                ></v-progress-circular>
                <v-btn fab small color="primary" v-if="this.user.role === 'admin' && !this.edit.ContactEmail && this.isLoading === false"
                       @click="edit.ContactEmail = !edit.ContactEmail">
                    <i class="material-icons ml2">
                        create
                    </i>
                </v-btn>
                <v-flex v-if="edit.ContactEmail === true">
                    <v-text-field
                            v-model="contactInfo.ContactEmail"
                            label="Uus e-mail"
                            :rules="emailRules"
                    ></v-text-field>
                    <v-btn color="primary" small fab>
                        <i class="material-icons" @click="change('ContactEmail', contactInfo.ContactEmail, user.role)">
                            check
                        </i>
                    </v-btn>
                    <v-btn color="error" fab small @click="edit.ContactEmail = !edit.ContactEmail">
                        <i class="material-icons">
                            clear
                        </i>
                    </v-btn>
                </v-flex>
            </p>

            <p>Aadress: {{ this.contactInfo.ContactAddress }}
                <v-progress-circular
                        v-show="isLoading === true"
                        indeterminate
                        color="primary"
                ></v-progress-circular>
                <v-btn fab small color="primary" v-if="this.user.role === 'admin' && !this.edit.ContactAddress && this.isLoading === false"
                       @click="edit.ContactAddress = !edit.ContactAddress">
                    <i class="material-icons ml2" v-if="this.user.role === 'admin'">
                        create
                    </i>
                </v-btn>
                <v-flex v-if="edit.ContactAddress === true">
                    <v-text-field
                            v-model="contactInfo.ContactAddress"
                            label="Uus aadress"
                            :rules="addressRules"
                            :counter="100"
                    ></v-text-field>
                    <v-btn color="primary" small fab>
                        <i class="material-icons"
                           @click="change('ContactAddress', contactInfo.ContactAddress, user.role)">
                            check
                        </i>
                    </v-btn>
                    <v-btn color="error" fab small @click="edit.ContactAddress = !edit.ContactAddress">
                        <i class="material-icons">
                            clear
                        </i>
                    </v-btn>
                </v-flex>
                <!--sucess alert-->
                <v-alert v-model="addSuccess" dismissible type="success">
                    {{ this.success }}
                </v-alert>
            </p>

            <v-divider></v-divider>

            <div class="map-responsive">
                <iframe class="mt-3"
                        src="https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2099.1299699407477!2d22.48022771593373!3
                    d58.25621418129626!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x46f26cfd32c602a1%3A0x73cbeee5e9dbb6f6!2sKuressaare+Ametikool!5e0!3m2!1sen!2see!4v1551468732820"
                        width="400" height="300" frameborder="0" style="border:0" allowfullscreen>
                </iframe>
            </div>
        </v-flex>
    </v-layout>
</template>

<script>
    import {mapGetters} from "vuex";

    export default {
        name: "Contact",
        data() {
            return {
                contactInfo: {
                    contactNumber: '',
                    contactEmail: '',
                    contactAddress: '',
                },
                error: null,
                success: null,
                isLoading: false,
                isValidated: false,
                addSuccess: false,
                edit: {
                    ContactNumber: false,
                    ContactEmail: false,
                    ContactAddress: false,
                },
                //If new number is empty, show error message
                numberRules: [
                    validation => !!validation || 'Palun sisestage number!',

                ],
                //If new email is empty, show error message
                //If email format is wrong, show error message
                emailRules: [
                    validation => /.+@.+/.test(validation) || 'E-mail peab olema korrektne!',
                    validation => !!validation || 'Palun sisestage e-mail!',
                ],
                //If new address is empty, show error message
                addressRules: [
                    validation => !!validation || 'Palun sisestage aadress!',
                ],
            }
        },
        //Get contactinfo and show loader
        created() {
            this.isLoading = true;
            axios.get('api/contactInfo').then(response => {
                this.contactInfo = response.data;
                this.isLoading = false;
            })
        },
        //Get logged in user info
        computed: {
            ...mapGetters([
                'user'
            ])
        },
        //change info
        //show success alert when done
        methods: {
            change(key, value, userRole) {
                axios.post('/api/contactInfo', {
                    key: key,
                    value: value,
                    userRole: userRole,
                }).then(response => {
                    this.success = response.data.message;
                    this.addSuccess = true;
                    this.edit[key] = !this.edit[key];
                });
            }
        }
    }
</script>
<!--Make iframe responsive-->
<style scoped>
    .map-responsive {
        overflow: hidden;
        padding-bottom: 56.25%;
        position: relative;
        height: 0;
        /*max-width: 50%;*/
    }

    .map-responsive iframe {
        left: 0;
        top: 0;
        height: 100%;
        width: 100%;
        position: absolute;
    }
</style>